#ifndef COMPOSE_MEMFUN_HH
#define COMPOSE_MEMFUN_HH

#include "compose.hh"

namespace FuncImpl
{

    // for member function pointers, just use the return type
    template<typename RT,typename Object,typename ArgSet>
    struct RTHelper<RT(Object::*)(),ArgSet>
    {
	typedef RT Type;
    };

    template<typename RT,typename Object,
	     typename A1,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1),ArgSet>
    {
	typedef RT Type;
    };
    
    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2),ArgSet>
    {
	typedef RT Type;
    };

    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3),ArgSet>
    {
	typedef RT Type;
    };

    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4),ArgSet>
    {
	typedef RT Type;
    };

    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4,A5),ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4,A5,A6),ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4,A5,A6,A7),ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4,A5,A6,A7,A8),ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename A9,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4,A5,A6,A7,A8,A9),ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename A9,
	     typename A10,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10),ArgSet>
    {
	typedef RT Type;
    };

    // for const member function pointers, just use the return type
    template<typename RT,typename Object,typename ArgSet>
    struct RTHelper<RT(Object::*)() const,ArgSet>
    {
	typedef RT Type;
    };

    template<typename RT,typename Object,
	     typename A1,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1) const,ArgSet>
    {
	typedef RT Type;
    };
    
    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2) const,ArgSet>
    {
	typedef RT Type;
    };

    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3) const,ArgSet>
    {
	typedef RT Type;
    };

    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4) const,ArgSet>
    {
	typedef RT Type;
    };

    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4,A5) const,ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4,A5,A6) const,ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4,A5,A6,A7) const,ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4,A5,A6,A7,A8) const,ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename A9,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4,A5,A6,A7,A8,A9) const,ArgSet>
    {
	typedef RT Type;
    };
    template<typename RT,typename Object,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename A9,
	     typename A10,
	     typename ArgSet>
    struct RTHelper<RT(Object::*)(A1,A2,A3,A4,A5,A6,A7,A8,A9,A10) const,ArgSet>
    {
	typedef RT Type;
    };

    template<typename T>
    struct DerivedHelper
    {
	typedef char Small;
	struct Big
	{
	    Small dummy[2];
	};

	static Small check(const volatile T* p);
	static Big check(...);
    };

    template<typename T>
    struct RemoveRef
    {
	typedef T Type;
    };

    template<typename T>
    struct RemoveRef<T&>
    {
	typedef typename RemoveRef<T>::Type Type;
    };

    template<typename T>
    struct RemoveRef<Holder::RefHolder<T> >
    {
	typedef typename RemoveRef<T>::Type Type;
    };

    template<typename T>
    struct RemoveRef<const Holder::RefHolder<T> >
    {
	typedef typename RemoveRef<T>::Type Type;
    };

    template<typename T,typename U>
    struct IsPubliclyDerivedFrom
    {
	typedef typename RemoveRef<T>::Type TNoRef;
	typedef typename RemoveRef<U>::Type UNoRef;
	
	static const bool result=sizeof(DerivedHelper<UNoRef>::check(ExprType::makeT<const volatile TNoRef*>()))
	    ==sizeof(DerivedHelper<UNoRef>::Small);
    };

    template<typename Object,typename ArgSet,typename CAS,
	     bool isRef=IsPubliclyDerivedFrom<
                            typename ArgSets::TransformArgSetResult<
                                typename ArgSet::Arg,CAS>::Type,
	                    Object>::result
    >
    struct GetObjectHelper
    {
	static Object& getObject(const ArgSet& as,const CAS& cas)
	{
	    typedef ArgSets::GetASEntry<ArgSet,1> ObjArg;
	    return *transformArg(ObjArg::getVal(as),cas);
	}
    };

    template<typename Object,typename ArgSet,typename CAS>
    struct GetObjectHelper<Object,ArgSet,CAS,true>
    {
	static Object& getObject(const ArgSet& as,const CAS& cas)
	{
	    typedef ArgSets::GetASEntry<ArgSet,1> ObjArg;
	    return transformArg(ObjArg::getVal(as),cas);
	}
    };

    template<typename RT,typename Object,typename Func,typename ArgSet,typename CAS,unsigned numArgs>
    struct MemFunCallerHelper
    {};
    
    // call member functions appropriately
    template<typename RT,typename Object,typename Func,typename AS,typename CAS>
    struct MemFunCallerHelper<RT,Object,Func,AS,CAS,0>
    {
	static RT call(const Func& func,const AS& as,const CAS& cas)
	{
	    return (GetObjectHelper<Object,AS,CAS>::getObject(as,cas).*func)();
	}
    };

    template<typename RT,typename Object,typename Func,typename AS,typename CAS>
    struct MemFunCallerHelper<RT,Object,Func,AS,CAS,1>
    {
	typedef typename AS::Base ArgSet;
	typedef ArgSets::GetASEntry<ArgSet,1> Arg1;
	
	static RT call(const Func& func,const AS& as,const CAS& cas)
	{
	    return (GetObjectHelper<Object,AS,CAS>::getObject(as,cas).*func)(transformArg(Arg1::getVal(as),cas));
	}
    };
    
    template<typename RT,typename Object,typename Func,typename AS,typename CAS>
    struct MemFunCallerHelper<RT,Object,Func,AS,CAS,2>
    {
	typedef typename AS::Base ArgSet;
	typedef ArgSets::GetASEntry<ArgSet,1> Arg1;
	typedef ArgSets::GetASEntry<ArgSet,2> Arg2;
	
	static RT call(const Func& func,const AS& as,const CAS& cas)
	{
	    return (GetObjectHelper<Object,AS,CAS>::getObject(as,cas).*func)(transformArg(Arg1::getVal(as),cas),
										 transformArg(Arg2::getVal(as),cas));
	}
    };
    
    template<typename RT,typename Object,typename Func,typename AS,typename CAS>
    struct MemFunCallerHelper<RT,Object,Func,AS,CAS,3>
    {
	typedef typename AS::Base ArgSet;
	typedef ArgSets::GetASEntry<ArgSet,1> Arg1;
	typedef ArgSets::GetASEntry<ArgSet,2> Arg2;
	typedef ArgSets::GetASEntry<ArgSet,3> Arg3;
	
	static RT call(const Func& func,const AS& as,const CAS& cas)
	{
	    return (GetObjectHelper<Object,AS,CAS>::getObject(as,cas).*func)(transformArg(Arg1::getVal(as),cas),
										 transformArg(Arg2::getVal(as),cas),
										 transformArg(Arg3::getVal(as),cas));
	}
    };
    
    template<typename RT,typename Object,typename Func,typename AS,typename CAS>
    struct MemFunCallerHelper<RT,Object,Func,AS,CAS,4>
    {
	typedef typename AS::Base ArgSet;
	typedef ArgSets::GetASEntry<ArgSet,1> Arg1;
	typedef ArgSets::GetASEntry<ArgSet,2> Arg2;
	typedef ArgSets::GetASEntry<ArgSet,3> Arg3;
	typedef ArgSets::GetASEntry<ArgSet,4> Arg4;
	
	static RT call(const Func& func,const AS& as,const CAS& cas)
	{
	    return (GetObjectHelper<Object,AS,CAS>::getObject(as,cas).*func)(transformArg(Arg1::getVal(as),cas),
										 transformArg(Arg2::getVal(as),cas),
										 transformArg(Arg3::getVal(as),cas),
										 transformArg(Arg4::getVal(as),cas));
	}
    };
    
    template<typename RT,typename Object,typename Func,typename AS,typename CAS>
    struct MemFunCallerHelper<RT,Object,Func,AS,CAS,5>
    {
	typedef typename AS::Base ArgSet;
	typedef ArgSets::GetASEntry<ArgSet,1> Arg1;
	typedef ArgSets::GetASEntry<ArgSet,2> Arg2;
	typedef ArgSets::GetASEntry<ArgSet,3> Arg3;
	typedef ArgSets::GetASEntry<ArgSet,4> Arg4;
	typedef ArgSets::GetASEntry<ArgSet,5> Arg5;
	
	static RT call(const Func& func,const AS& as,const CAS& cas)
	{
	    return (GetObjectHelper<Object,AS,CAS>::getObject(as,cas).*func)(transformArg(Arg1::getVal(as),cas),
										 transformArg(Arg2::getVal(as),cas),
										 transformArg(Arg3::getVal(as),cas),
										 transformArg(Arg4::getVal(as),cas),
										 transformArg(Arg5::getVal(as),cas));
	}
    };
    
    template<typename RT,typename Object,typename Func,typename AS,typename CAS>
    struct MemFunCallerHelper<RT,Object,Func,AS,CAS,6>
    {
	typedef typename AS::Base ArgSet;
	typedef ArgSets::GetASEntry<ArgSet,1> Arg1;
	typedef ArgSets::GetASEntry<ArgSet,2> Arg2;
	typedef ArgSets::GetASEntry<ArgSet,3> Arg3;
	typedef ArgSets::GetASEntry<ArgSet,4> Arg4;
	typedef ArgSets::GetASEntry<ArgSet,5> Arg5;
	typedef ArgSets::GetASEntry<ArgSet,6> Arg6;
	
	static RT call(const Func& func,const AS& as,const CAS& cas)
	{
	    return (GetObjectHelper<Object,AS,CAS>::getObject(as,cas).*func)(transformArg(Arg1::getVal(as),cas),
										 transformArg(Arg2::getVal(as),cas),
										 transformArg(Arg3::getVal(as),cas),
										 transformArg(Arg4::getVal(as),cas),
										 transformArg(Arg5::getVal(as),cas),
										 transformArg(Arg6::getVal(as),cas));
	}
    };
    
    template<typename RT,typename Object,typename Func,typename AS,typename CAS>
    struct MemFunCallerHelper<RT,Object,Func,AS,CAS,7>
    {
	typedef typename AS::Base ArgSet;
	typedef ArgSets::GetASEntry<ArgSet,1> Arg1;
	typedef ArgSets::GetASEntry<ArgSet,2> Arg2;
	typedef ArgSets::GetASEntry<ArgSet,3> Arg3;
	typedef ArgSets::GetASEntry<ArgSet,4> Arg4;
	typedef ArgSets::GetASEntry<ArgSet,5> Arg5;
	typedef ArgSets::GetASEntry<ArgSet,6> Arg6;
	typedef ArgSets::GetASEntry<ArgSet,7> Arg7;
	
	static RT call(const Func& func,const AS& as,const CAS& cas)
	{
	    return (GetObjectHelper<Object,AS,CAS>::getObject(as,cas).*func)(transformArg(Arg1::getVal(as),cas),
										 transformArg(Arg2::getVal(as),cas),
										 transformArg(Arg3::getVal(as),cas),
										 transformArg(Arg4::getVal(as),cas),
										 transformArg(Arg5::getVal(as),cas),
										 transformArg(Arg6::getVal(as),cas),
										 transformArg(Arg7::getVal(as),cas));
	}
    };
    
    template<typename RT,typename Object,typename Func,typename AS,typename CAS>
    struct MemFunCallerHelper<RT,Object,Func,AS,CAS,8>
    {
	typedef typename AS::Base ArgSet;
	typedef ArgSets::GetASEntry<ArgSet,1> Arg1;
	typedef ArgSets::GetASEntry<ArgSet,2> Arg2;
	typedef ArgSets::GetASEntry<ArgSet,3> Arg3;
	typedef ArgSets::GetASEntry<ArgSet,4> Arg4;
	typedef ArgSets::GetASEntry<ArgSet,5> Arg5;
	typedef ArgSets::GetASEntry<ArgSet,6> Arg6;
	typedef ArgSets::GetASEntry<ArgSet,7> Arg7;
	typedef ArgSets::GetASEntry<ArgSet,8> Arg8;
	
	static RT call(const Func& func,const AS& as,const CAS& cas)
	{
	    return (GetObjectHelper<Object,AS,CAS>::getObject(as,cas).*func)(transformArg(Arg1::getVal(as),cas),
										 transformArg(Arg2::getVal(as),cas),
										 transformArg(Arg3::getVal(as),cas),
										 transformArg(Arg4::getVal(as),cas),
										 transformArg(Arg5::getVal(as),cas),
										 transformArg(Arg6::getVal(as),cas),
										 transformArg(Arg7::getVal(as),cas),
										 transformArg(Arg8::getVal(as),cas));
	}
    };
    
    template<typename RT,typename Object,typename Func,typename AS,typename CAS>
    struct MemFunCallerHelper<RT,Object,Func,AS,CAS,9>
    {
	typedef typename AS::Base ArgSet;
	typedef ArgSets::GetASEntry<ArgSet,1> Arg1;
	typedef ArgSets::GetASEntry<ArgSet,2> Arg2;
	typedef ArgSets::GetASEntry<ArgSet,3> Arg3;
	typedef ArgSets::GetASEntry<ArgSet,4> Arg4;
	typedef ArgSets::GetASEntry<ArgSet,5> Arg5;
	typedef ArgSets::GetASEntry<ArgSet,6> Arg6;
	typedef ArgSets::GetASEntry<ArgSet,7> Arg7;
	typedef ArgSets::GetASEntry<ArgSet,8> Arg8;
	typedef ArgSets::GetASEntry<ArgSet,9> Arg9;
	
	static RT call(const Func& func,const AS& as,const CAS& cas)
	{
	    return (GetObjectHelper<Object,AS,CAS>::getObject(as,cas).*func)(transformArg(Arg1::getVal(as),cas),
										 transformArg(Arg2::getVal(as),cas),
										 transformArg(Arg3::getVal(as),cas),
										 transformArg(Arg4::getVal(as),cas),
										 transformArg(Arg5::getVal(as),cas),
										 transformArg(Arg6::getVal(as),cas),
										 transformArg(Arg7::getVal(as),cas),
										 transformArg(Arg8::getVal(as),cas),
										 transformArg(Arg9::getVal(as),cas));
	}
    };

    // CallerHelper specialization that delegates to the appropriate MemFunCallerHelper instance

    // non-const member functions
    template<typename Object,typename RT,typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(),ArgSet,CAS,1>
    {
	typedef RT (Object::*Func)();

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,Object,Func,ArgSet,CAS,0>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1),ArgSet,CAS,2>
    {
	typedef RT (Object::*Func)(A1);

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,Object,Func,ArgSet,CAS,1>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2),ArgSet,CAS,3>
    {
	typedef RT (Object::*Func)(A1,A2);

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,Object,Func,ArgSet,CAS,2>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3),ArgSet,CAS,4>
    {
	typedef RT (Object::*Func)(A1,A2,A3);

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,Object,Func,ArgSet,CAS,3>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3,A4),ArgSet,CAS,5>
    {
	typedef RT (Object::*Func)(A1,A2,A3,A4);

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,Object,Func,ArgSet,CAS,4>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3,A4,A5),ArgSet,CAS,6>
    {
	typedef RT (Object::*Func)(A1,A2,A3,A4,A5);

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,Object,Func,ArgSet,CAS,5>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3,A4,A5,A6),ArgSet,CAS,7>
    {
	typedef RT (Object::*Func)(A1,A2,A3,A4,A5,A6);

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,Object,Func,ArgSet,CAS,6>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3,A4,A5,A6,A7),ArgSet,CAS,8>
    {
	typedef RT (Object::*Func)(A1,A2,A3,A4,A5,A6,A7);

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,Object,Func,ArgSet,CAS,7>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3,A4,A5,A6,A7,A8),ArgSet,CAS,9>
    {
	typedef RT (Object::*Func)(A1,A2,A3,A4,A5,A6,A7,A8);

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,Object,Func,ArgSet,CAS,8>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename A9,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3,A4,A5,A6,A7,A8,A9),ArgSet,CAS,10>
    {
	typedef RT (Object::*Func)(A1,A2,A3,A4,A5,A6,A7,A8,A9);

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,Object,Func,ArgSet,CAS,9>::call(func,as,cas);
	}
    };

    // const member functions
    template<typename Object,typename RT,typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)() const,ArgSet,CAS,1>
    {
	typedef RT (Object::*Func)() const;

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,const Object,Func,ArgSet,CAS,0>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1) const,ArgSet,CAS,2>
    {
	typedef RT (Object::*Func)(A1) const;

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,const Object,Func,ArgSet,CAS,1>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2) const,ArgSet,CAS,3>
    {
	typedef RT (Object::*Func)(A1,A2) const;

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,const Object,Func,ArgSet,CAS,2>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3) const,ArgSet,CAS,4>
    {
	typedef RT (Object::*Func)(A1,A2,A3) const;

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,const Object,Func,ArgSet,CAS,3>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3,A4) const,ArgSet,CAS,5>
    {
	typedef RT (Object::*Func)(A1,A2,A3,A4) const;

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,const Object,Func,ArgSet,CAS,4>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3,A4,A5) const,ArgSet,CAS,6>
    {
	typedef RT (Object::*Func)(A1,A2,A3,A4,A5) const;

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,const Object,Func,ArgSet,CAS,5>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3,A4,A5,A6) const,ArgSet,CAS,7>
    {
	typedef RT (Object::*Func)(A1,A2,A3,A4,A5,A6) const;

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,const Object,Func,ArgSet,CAS,6>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3,A4,A5,A6,A7) const,ArgSet,CAS,8>
    {
	typedef RT (Object::*Func)(A1,A2,A3,A4,A5,A6,A7) const;

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,const Object,Func,ArgSet,CAS,7>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3,A4,A5,A6,A7,A8) const,ArgSet,CAS,9>
    {
	typedef RT (Object::*Func)(A1,A2,A3,A4,A5,A6,A7,A8) const;

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,const Object,Func,ArgSet,CAS,8>::call(func,as,cas);
	}
    };

    template<typename Object,typename RT,
	     typename A1,
	     typename A2,
	     typename A3,
	     typename A4,
	     typename A5,
	     typename A6,
	     typename A7,
	     typename A8,
	     typename A9,
	     typename ArgSet,typename CAS>
    struct CallerHelper<RT (Object::*)(A1,A2,A3,A4,A5,A6,A7,A8,A9) const,ArgSet,CAS,10>
    {
	typedef RT (Object::*Func)(A1,A2,A3,A4,A5,A6,A7,A8,A9) const;

	static RT callFunc(const Func& func,const ArgSet& as,const CAS& cas)
	{
	    return MemFunCallerHelper<RT,const Object,Func,ArgSet,CAS,9>::call(func,as,cas);
	}
    };

}

#endif
